var samplejs = {};
samplejs.uiWebview_SearchResultCount = 0;
var _results = "";
var neighSize = 20;

/*!
 @method     uiWebview_HighlightAllOccurencesOfStringForElement
 @abstract   // helper function, recursively searches in elements and their child nodes
 @discussion // helper function, recursively searches in elements and their child nodes
 
 element    - HTML elements
 keyword    - string to search
 */
 
samplejs.message = function(){
window.AndroidFunction.logFromJavaScript("From java Script");
};

samplejs.addition = function(){
var sum=10+10;
window.AndroidFunction.logFromJavaScript(sum);
};

samplejs.searchandhighlight= function(keyword) {
    window.AndroidFunction.logFromJavaScript("Inside searchandhighlight");
    samplejs.uiWebview_SearchResultCount = 0;
    window.AndroidFunction.logFromJavaScript("Inside searchandhighlight2");
    samplejs.MyApp_HighlightAllOccurencesOfStringForElement(document.body, keyword.toLowerCase());
    window.AndroidFunction.logFromJavaScript("Inside searchandhighlight3");
    window.AndroidFunction.searchCount(samplejs.uiWebview_SearchResultCount);
    window.AndroidFunction.logFromJavaScript("Inside searchandhighlight4");
};

samplejs.MyApp_HighlightAllOccurencesOfStringForElement= function(element,keyword)  {
    //window.AndroidFunction.logFromJavaScript("Inside MyApp_HighlightAllOccurencesOfStringForElement");
    if (element) {
        if (element.nodeType == 3) {        // Text node
            while (true) {
                //if (counter < 1) {
                var value = element.nodeValue;  // Search for keyword in text node
                var idx = value.toLowerCase().indexOf(keyword);
                
                if (idx < 0) break;             // not found, abort
                
                //(value.split);
                try{
                
                //we create a SPAN element for every parts of matched keywords
                var span = document.createElement("span");
                 span.setAttribute("class","uiWebviewHighlight");
                                span.style.backgroundColor="black";
                                span.style.color="white";

                var text = document.createTextNode(value.substr(idx,keyword.length));
                span.appendChild(text);

                 var rightText = document.createTextNode(value.substr(idx+keyword.length));
                 element.deleteData(idx, value.length - idx);

                 var next = element.nextSibling;
                 element.parentNode.insertBefore(rightText, next);
                 element.parentNode.insertBefore(span, rightText);

                  var leftNeighText = element.nodeValue.substr(element.length - neighSize, neighSize);
                  var rightNeighText = rightText.nodeValue.substr(0, neighSize);

                   var pos = getPos(span);

                   element = rightText;
                
                samplejs.uiWebview_SearchResultCount++;    // update the counter
                
                    console += "Span className: " + span.className + "\n";
                    console += "Span position: (" + pos.x + ", " + pos.y + ")\n";

                    _results += pos.x + "," + pos.y + "," + escape(leftNeighText + text.nodeValue + rightNeighText) + ";";

                    _results;
                }
                catch(err){

                    // exception if tags goes in infinite loop for text node ///
                }
            }
        } else if (element.nodeType == 1) { // Element node
            if (element.style.display != "none" && element.nodeName.toLowerCase() != 'select') {
                for (var i=element.childNodes.length-1; i>=0; i--) {
                    samplejs.MyApp_HighlightAllOccurencesOfStringForElement(element.childNodes[i],keyword);
                }
            }
        }
    }
    
};


// the main entry point to start the search
function uiWebview_HighlightAllOccurencesOfString(keyword) {
    uiWebview_RemoveAllHighlights();
    uiWebview_HighlightAllOccurencesOfStringForElement(document.body, keyword.toLowerCase());
}

// helper function, recursively removes the highlights in elements and their childs
function uiWebview_RemoveAllHighlightsForElement(element) {
    if (element) {
        if (element.nodeType == 1) {
            if (element.getAttribute("class") == "uiWebviewHighlight") {
                var text = element.removeChild(element.firstChild);
                element.parentNode.insertBefore(text,element);
                element.parentNode.removeChild(element);
                return true;
            } else {
                var normalize = false;
                for (var i=element.childNodes.length-1; i>=0; i--) {
                    if (uiWebview_RemoveAllHighlightsForElement(element.childNodes[i])) {
                        normalize = true;
                    }
                }
                if (normalize) {
                    element.normalize();
                }
            }
        }
    }
    return false;
}

// the main entry point to remove the highlights
function uiWebview_RemoveAllHighlights() {
    uiWebview_SearchResultCount = 0;
    uiWebview_RemoveAllHighlightsForElement(document.body);
}